/* totem-zeitgeist-plugin.c generated by valac 0.12.0, the Vala compiler
 * generated from totem-zeitgeist-plugin.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <totem-plugin.h>
#include <zeitgeist.h>
#include <totem.h>
#include <bacon-video-widget.h>
#include <gio/gio.h>


#define TYPE_MEDIA_INFO (media_info_get_type ())
typedef struct _MediaInfo MediaInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZEITGEIST_PLUGIN (zeitgeist_plugin_get_type ())
#define ZEITGEIST_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ZEITGEIST_PLUGIN, ZeitgeistPlugin))
#define ZEITGEIST_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ZEITGEIST_PLUGIN, ZeitgeistPluginClass))
#define IS_ZEITGEIST_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ZEITGEIST_PLUGIN))
#define IS_ZEITGEIST_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ZEITGEIST_PLUGIN))
#define ZEITGEIST_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ZEITGEIST_PLUGIN, ZeitgeistPluginClass))

typedef struct _ZeitgeistPlugin ZeitgeistPlugin;
typedef struct _ZeitgeistPluginClass ZeitgeistPluginClass;
typedef struct _ZeitgeistPluginPrivate ZeitgeistPluginPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MediaInfo {
	gint64 timestamp;
	gboolean sent_access;
	gchar* mrl;
	gchar* mimetype;
	gchar* title;
	gchar* interpretation;
	gchar* artist;
	gchar* album;
};

struct _ZeitgeistPlugin {
	TotemPlugin parent_instance;
	ZeitgeistPluginPrivate * priv;
};

struct _ZeitgeistPluginClass {
	TotemPluginClass parent_class;
};

struct _ZeitgeistPluginPrivate {
	MediaInfo current_media;
	guint media_info_timeout;
	guint timeout_id;
	gulong* signals;
	gint signals_length1;
	gint _signals_size_;
	ZeitgeistLog* zg_log;
	TotemObject* totem_object;
};


static gpointer zeitgeist_plugin_parent_class = NULL;
static GType zeitgeist_plugin_type_id = 0;

GType media_info_get_type (void) G_GNUC_CONST;
MediaInfo* media_info_dup (const MediaInfo* self);
void media_info_free (MediaInfo* self);
void media_info_copy (const MediaInfo* self, MediaInfo* dest);
void media_info_destroy (MediaInfo* self);
GType zeitgeist_plugin_get_type (void) G_GNUC_CONST;
GType zeitgeist_plugin_register_type (GTypeModule * module);
#define ZEITGEIST_PLUGIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ZEITGEIST_PLUGIN, ZeitgeistPluginPrivate))
enum  {
	ZEITGEIST_PLUGIN_DUMMY_PROPERTY
};
static gboolean zeitgeist_plugin_real_activate (TotemPlugin* base, TotemObject* totem, GError** error);
static void zeitgeist_plugin_file_opened (ZeitgeistPlugin* self, const gchar* mrl, TotemObject* totem);
static void _vala_array_add1 (gulong** array, int* length, int* size, gulong value);
static void zeitgeist_plugin_file_closed (ZeitgeistPlugin* self, TotemObject* totem);
static void _vala_array_add2 (gulong** array, int* length, int* size, gulong value);
static void zeitgeist_plugin_metadata_changed (ZeitgeistPlugin* self, const gchar* artist, const gchar* title, const gchar* album, guint track_num, TotemObject* totem);
static void _vala_array_add3 (gulong** array, int* length, int* size, gulong value);
static void zeitgeist_plugin_playing_changed (ZeitgeistPlugin* self);
static void _vala_array_add4 (gulong** array, int* length, int* size, gulong value);
static void zeitgeist_plugin_real_deactivate (TotemPlugin* base, TotemObject* totem);
static void zeitgeist_plugin_restart_watcher (ZeitgeistPlugin* self, guint interval);
static gboolean zeitgeist_plugin_timeout_cb (ZeitgeistPlugin* self);
static gboolean _zeitgeist_plugin_timeout_cb_gsource_func (gpointer self);
static gboolean zeitgeist_plugin_wait_for_media_info (ZeitgeistPlugin* self);
static gboolean _zeitgeist_plugin_wait_for_media_info_gsource_func (gpointer self);
static void zeitgeist_plugin_send_event_to_zg (ZeitgeistPlugin* self, gboolean leave_event);
ZeitgeistPlugin* zeitgeist_plugin_new (void);
ZeitgeistPlugin* zeitgeist_plugin_construct (GType object_type);
static void zeitgeist_plugin_finalize (GObject* obj);
GType register_totem_plugin (GTypeModule* module);


void media_info_copy (const MediaInfo* self, MediaInfo* dest) {
	dest->timestamp = self->timestamp;
	dest->sent_access = self->sent_access;
	dest->mrl = g_strdup (self->mrl);
	dest->mimetype = g_strdup (self->mimetype);
	dest->title = g_strdup (self->title);
	dest->interpretation = g_strdup (self->interpretation);
	dest->artist = g_strdup (self->artist);
	dest->album = g_strdup (self->album);
}


void media_info_destroy (MediaInfo* self) {
	_g_free0 ((*self).mrl);
	_g_free0 ((*self).mimetype);
	_g_free0 ((*self).title);
	_g_free0 ((*self).interpretation);
	_g_free0 ((*self).artist);
	_g_free0 ((*self).album);
}


MediaInfo* media_info_dup (const MediaInfo* self) {
	MediaInfo* dup;
	dup = g_new0 (MediaInfo, 1);
	media_info_copy (self, dup);
	return dup;
}


void media_info_free (MediaInfo* self) {
	media_info_destroy (self);
	g_free (self);
}


GType media_info_get_type (void) {
	static volatile gsize media_info_type_id__volatile = 0;
	if (g_once_init_enter (&media_info_type_id__volatile)) {
		GType media_info_type_id;
		media_info_type_id = g_boxed_type_register_static ("MediaInfo", (GBoxedCopyFunc) media_info_dup, (GBoxedFreeFunc) media_info_free);
		g_once_init_leave (&media_info_type_id__volatile, media_info_type_id);
	}
	return media_info_type_id__volatile;
}


static void _vala_array_add1 (gulong** array, int* length, int* size, gulong value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gulong, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add2 (gulong** array, int* length, int* size, gulong value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gulong, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add3 (gulong** array, int* length, int* size, gulong value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gulong, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add4 (gulong** array, int* length, int* size, gulong value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gulong, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static gboolean zeitgeist_plugin_real_activate (TotemPlugin* base, TotemObject* totem, GError** error) {
	ZeitgeistPlugin * self;
	gboolean result = FALSE;
	ZeitgeistLog* _tmp0_ = NULL;
	MediaInfo _tmp1_ = {0};
	MediaInfo _tmp2_ = {0};
	gulong _tmp3_;
	gulong _tmp4_;
	gulong _tmp5_;
	gulong _tmp6_;
	self = (ZeitgeistPlugin*) base;
	g_return_val_if_fail (totem != NULL, FALSE);
	_tmp0_ = zeitgeist_log_new ();
	_g_object_unref0 (self->priv->zg_log);
	self->priv->zg_log = _tmp0_;
	self->priv->totem_object = totem;
	memset (&_tmp1_, 0, sizeof (MediaInfo));
	_tmp2_ = _tmp1_;
	media_info_destroy (&self->priv->current_media);
	self->priv->current_media = _tmp2_;
	_tmp3_ = g_signal_connect_swapped (totem, "file-opened", (GCallback) zeitgeist_plugin_file_opened, self);
	_vala_array_add1 (&self->priv->signals, &self->priv->signals_length1, &self->priv->_signals_size_, _tmp3_);
	_tmp4_ = g_signal_connect_swapped (totem, "file-closed", (GCallback) zeitgeist_plugin_file_closed, self);
	_vala_array_add2 (&self->priv->signals, &self->priv->signals_length1, &self->priv->_signals_size_, _tmp4_);
	_tmp5_ = g_signal_connect_swapped (totem, "metadata-updated", (GCallback) zeitgeist_plugin_metadata_changed, self);
	_vala_array_add3 (&self->priv->signals, &self->priv->signals_length1, &self->priv->_signals_size_, _tmp5_);
	_tmp6_ = g_signal_connect_swapped (totem, "notify::playing", (GCallback) zeitgeist_plugin_playing_changed, self);
	_vala_array_add4 (&self->priv->signals, &self->priv->signals_length1, &self->priv->_signals_size_, _tmp6_);
	result = TRUE;
	return result;
}


static void zeitgeist_plugin_real_deactivate (TotemPlugin* base, TotemObject* totem) {
	ZeitgeistPlugin * self;
	self = (ZeitgeistPlugin*) base;
	g_return_if_fail (totem != NULL);
	zeitgeist_plugin_file_closed (self, totem);
	self->priv->totem_object = NULL;
	{
		gulong* id_collection;
		int id_collection_length1;
		int id_it;
		id_collection = self->priv->signals;
		id_collection_length1 = self->priv->signals_length1;
		for (id_it = 0; id_it < self->priv->signals_length1; id_it = id_it + 1) {
			gulong id;
			id = id_collection[id_it];
			{
				g_signal_handler_disconnect (totem, id);
			}
		}
	}
	self->priv->signals = (g_free (self->priv->signals), NULL);
	self->priv->signals = NULL;
	self->priv->signals_length1 = 0;
	self->priv->_signals_size_ = 0;
	if (self->priv->media_info_timeout != 0) {
		g_source_remove (self->priv->media_info_timeout);
	}
	if (self->priv->timeout_id != 0) {
		g_source_remove (self->priv->timeout_id);
	}
	self->priv->media_info_timeout = (guint) 0;
	self->priv->timeout_id = (guint) 0;
}


static gboolean _zeitgeist_plugin_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = zeitgeist_plugin_timeout_cb (self);
	return result;
}


static void zeitgeist_plugin_restart_watcher (ZeitgeistPlugin* self, guint interval) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_id != 0) {
		g_source_remove (self->priv->timeout_id);
	}
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, interval, _zeitgeist_plugin_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timeout_id = _tmp0_;
}


static gboolean _zeitgeist_plugin_wait_for_media_info_gsource_func (gpointer self) {
	gboolean result;
	result = zeitgeist_plugin_wait_for_media_info (self);
	return result;
}


static void zeitgeist_plugin_file_opened (ZeitgeistPlugin* self, const gchar* mrl, TotemObject* totem) {
	MediaInfo _tmp0_ = {0};
	MediaInfo _tmp1_ = {0};
	gchar* _tmp2_;
	GTimeVal cur_time = {0};
	gint64 _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mrl != NULL);
	g_return_if_fail (totem != NULL);
	if (self->priv->current_media.mrl != NULL) {
		zeitgeist_plugin_file_closed (self, totem);
	}
	memset (&_tmp0_, 0, sizeof (MediaInfo));
	_tmp1_ = _tmp0_;
	media_info_destroy (&self->priv->current_media);
	self->priv->current_media = _tmp1_;
	_tmp2_ = g_strdup (mrl);
	_g_free0 (self->priv->current_media.mrl);
	self->priv->current_media.mrl = _tmp2_;
	g_get_current_time (&cur_time);
	_tmp3_ = zeitgeist_timestamp_from_timeval (&cur_time);
	self->priv->current_media.timestamp = _tmp3_;
	if (self->priv->media_info_timeout == 0) {
		guint _tmp4_;
		_tmp4_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _zeitgeist_plugin_wait_for_media_info_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->media_info_timeout = _tmp4_;
		zeitgeist_plugin_restart_watcher (self, (guint) 15000);
	} else {
		g_warning ("totem-zeitgeist-plugin.vala:85: already had timeout!");
	}
}


static void zeitgeist_plugin_file_closed (ZeitgeistPlugin* self, TotemObject* totem) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (totem != NULL);
	if (self->priv->current_media.sent_access) {
		_tmp0_ = self->priv->current_media.mrl != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GTimeVal cur_time = {0};
		gint64 _tmp1_;
		g_get_current_time (&cur_time);
		_tmp1_ = zeitgeist_timestamp_from_timeval (&cur_time);
		self->priv->current_media.timestamp = _tmp1_;
		zeitgeist_plugin_send_event_to_zg (self, TRUE);
		_g_free0 (self->priv->current_media.mrl);
		self->priv->current_media.mrl = NULL;
	}
	if (self->priv->media_info_timeout != 0) {
		g_source_remove (self->priv->media_info_timeout);
	}
	self->priv->media_info_timeout = (guint) 0;
	if (self->priv->timeout_id != 0) {
		g_source_remove (self->priv->timeout_id);
	}
	self->priv->timeout_id = (guint) 0;
}


static void zeitgeist_plugin_metadata_changed (ZeitgeistPlugin* self, const gchar* artist, const gchar* title, const gchar* album, guint track_num, TotemObject* totem) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (totem != NULL);
	if (self->priv->media_info_timeout != 0) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = g_strdup (artist);
		_g_free0 (self->priv->current_media.artist);
		self->priv->current_media.artist = _tmp0_;
		_tmp1_ = g_strdup (title);
		_g_free0 (self->priv->current_media.title);
		self->priv->current_media.title = _tmp1_;
		_tmp2_ = g_strdup (album);
		_g_free0 (self->priv->current_media.album);
		self->priv->current_media.album = _tmp2_;
	}
}


static gboolean zeitgeist_plugin_timeout_cb (ZeitgeistPlugin* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->media_info_timeout != 0) {
		gchar* _tmp0_ = NULL;
		g_source_remove (self->priv->media_info_timeout);
		self->priv->media_info_timeout = (guint) 0;
		_tmp0_ = totem_get_short_title (self->priv->totem_object);
		_g_free0 (self->priv->current_media.title);
		self->priv->current_media.title = _tmp0_;
		self->priv->timeout_id = (guint) 0;
		zeitgeist_plugin_wait_for_media_info (self);
	}
	self->priv->timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


static gboolean zeitgeist_plugin_wait_for_media_info (ZeitgeistPlugin* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->current_media.title != NULL) {
		gboolean _tmp1_;
		_tmp1_ = totem_is_playing (self->priv->totem_object);
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GValue val = {0};
		GtkWidget* _tmp2_ = NULL;
		GtkWidget* _tmp3_;
		BaconVideoWidget* video;
		GValue _tmp4_ = {0};
		const gchar* _tmp5_ = NULL;
		gboolean _tmp6_;
		gchar* _tmp7_;
		GFile* _tmp8_ = NULL;
		GFile* f;
		gboolean _tmp9_;
		_tmp2_ = totem_get_video_widget (self->priv->totem_object);
		_tmp3_ = _tmp2_;
		video = BACON_IS_VIDEO_WIDGET (_tmp3_) ? ((BaconVideoWidget*) _tmp3_) : NULL;
		bacon_video_widget_get_metadata (video, BVW_INFO_HAS_VIDEO, &_tmp4_);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		val = _tmp4_;
		_tmp6_ = g_value_get_boolean (&val);
		if (_tmp6_) {
			_tmp5_ = ZEITGEIST_NFO_VIDEO;
		} else {
			_tmp5_ = ZEITGEIST_NFO_AUDIO;
		}
		_tmp7_ = g_strdup (_tmp5_);
		_g_free0 (self->priv->current_media.interpretation);
		self->priv->current_media.interpretation = _tmp7_;
		_tmp8_ = g_file_new_for_uri (self->priv->current_media.mrl);
		f = _tmp8_;
		_tmp9_ = g_file_query_exists (f, NULL);
		if (_tmp9_) {
			GFileInfo* _tmp10_ = NULL;
			GFileInfo* fi;
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_;
			_tmp10_ = g_file_query_info (f, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
			fi = _tmp10_;
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
			}
			_tmp11_ = g_file_info_get_content_type (fi);
			_tmp12_ = g_strdup (_tmp11_);
			_g_free0 (self->priv->current_media.mimetype);
			self->priv->current_media.mimetype = _tmp12_;
			_g_object_unref0 (fi);
			goto __finally0;
			__catch0_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				g_warning ("totem-zeitgeist-plugin.vala:146: %s", err->message);
				_g_error_free0 (err);
			}
			__finally0:
			if (_inner_error_ != NULL) {
				_g_object_unref0 (f);
				_g_object_unref0 (video);
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
		}
		zeitgeist_plugin_send_event_to_zg (self, FALSE);
		self->priv->current_media.sent_access = TRUE;
		if (self->priv->timeout_id != 0) {
			g_source_remove (self->priv->timeout_id);
		}
		self->priv->timeout_id = (guint) 0;
		self->priv->media_info_timeout = (guint) 0;
		result = FALSE;
		_g_object_unref0 (f);
		_g_object_unref0 (video);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		return result;
	}
	result = TRUE;
	return result;
}


static void zeitgeist_plugin_playing_changed (ZeitgeistPlugin* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	if (self->priv->media_info_timeout == 0) {
		_tmp0_ = self->priv->current_media.sent_access == FALSE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		zeitgeist_plugin_wait_for_media_info (self);
	}
	_tmp2_ = totem_is_playing (self->priv->totem_object);
	if (!_tmp2_) {
		_tmp1_ = self->priv->current_media.sent_access;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		zeitgeist_plugin_file_closed (self, self->priv->totem_object);
	}
}


static void zeitgeist_plugin_send_event_to_zg (ZeitgeistPlugin* self, gboolean leave_event) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (self->priv->current_media.mrl != NULL) {
		_tmp0_ = self->priv->current_media.title != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* event_interpretation;
		gchar* _tmp3_;
		gchar* origin;
		const gchar* _tmp4_ = NULL;
		const gchar* substr;
		ZeitgeistSubject* _tmp6_ = NULL;
		ZeitgeistSubject* subject;
		ZeitgeistEvent* _tmp7_ = NULL;
		ZeitgeistEvent* event;
		if (leave_event) {
			_tmp1_ = ZEITGEIST_ZG_LEAVE_EVENT;
		} else {
			_tmp1_ = ZEITGEIST_ZG_ACCESS_EVENT;
		}
		_tmp2_ = g_strdup (_tmp1_);
		event_interpretation = _tmp2_;
		_tmp3_ = g_strdup ("");
		origin = _tmp3_;
		_tmp4_ = g_utf8_strrchr (self->priv->current_media.mrl, (gssize) (-1), (gunichar) '/');
		substr = _tmp4_;
		if (substr != NULL) {
			gsize n;
			gchar* _tmp5_ = NULL;
			n = ((gchar*) substr) - ((gchar*) self->priv->current_media.mrl);
			_tmp5_ = g_strndup (self->priv->current_media.mrl, n);
			_g_free0 (origin);
			origin = _tmp5_;
		}
		_tmp6_ = zeitgeist_subject_new_full (self->priv->current_media.mrl, self->priv->current_media.interpretation, ZEITGEIST_NFO_FILE_DATA_OBJECT, self->priv->current_media.mimetype, origin, self->priv->current_media.title, "");
		subject = g_object_ref_sink (_tmp6_);
		_tmp7_ = zeitgeist_event_new_full (event_interpretation, ZEITGEIST_ZG_USER_ACTIVITY, "application://totem.desktop", subject, NULL, NULL);
		event = g_object_ref_sink (_tmp7_);
		zeitgeist_event_set_timestamp (event, self->priv->current_media.timestamp);
		zeitgeist_log_insert_events_no_reply (self->priv->zg_log, event, NULL, NULL);
		_g_object_unref0 (event);
		_g_object_unref0 (subject);
		_g_free0 (origin);
		_g_free0 (event_interpretation);
	}
}


ZeitgeistPlugin* zeitgeist_plugin_construct (GType object_type) {
	ZeitgeistPlugin * self = NULL;
	self = (ZeitgeistPlugin*) g_object_new (object_type, NULL);
	return self;
}


ZeitgeistPlugin* zeitgeist_plugin_new (void) {
	return zeitgeist_plugin_construct (TYPE_ZEITGEIST_PLUGIN);
}


static void zeitgeist_plugin_class_init (ZeitgeistPluginClass * klass) {
	zeitgeist_plugin_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ZeitgeistPluginPrivate));
	TOTEM_PLUGIN_CLASS (klass)->activate = zeitgeist_plugin_real_activate;
	TOTEM_PLUGIN_CLASS (klass)->deactivate = zeitgeist_plugin_real_deactivate;
	G_OBJECT_CLASS (klass)->finalize = zeitgeist_plugin_finalize;
}


static void zeitgeist_plugin_instance_init (ZeitgeistPlugin * self) {
	self->priv = ZEITGEIST_PLUGIN_GET_PRIVATE (self);
}


static void zeitgeist_plugin_finalize (GObject* obj) {
	ZeitgeistPlugin * self;
	self = ZEITGEIST_PLUGIN (obj);
	media_info_destroy (&self->priv->current_media);
	self->priv->signals = (g_free (self->priv->signals), NULL);
	_g_object_unref0 (self->priv->zg_log);
	G_OBJECT_CLASS (zeitgeist_plugin_parent_class)->finalize (obj);
}


GType zeitgeist_plugin_get_type (void) {
	return zeitgeist_plugin_type_id;
}


GType zeitgeist_plugin_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (ZeitgeistPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zeitgeist_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ZeitgeistPlugin), 0, (GInstanceInitFunc) zeitgeist_plugin_instance_init, NULL };
	zeitgeist_plugin_type_id = g_type_module_register_type (module, TOTEM_TYPE_PLUGIN, "ZeitgeistPlugin", &g_define_type_info, 0);
	return zeitgeist_plugin_type_id;
}


GType register_totem_plugin (GTypeModule* module) {
	GType result = 0UL;
	g_return_val_if_fail (module != NULL, 0UL);
	zeitgeist_plugin_register_type (module);
	result = TYPE_ZEITGEIST_PLUGIN;
	return result;
}



